// SPDX-License-Identifier: (GPL-2.0+ OR MIT)
/*
 * Copyright 2020 Technexion Ltd.
 *
 * Author: Ray Chang <ray.chang@technexion.com>
 *
 */

/dts-v1/;

#include "imx8mp-edm-g.dtsi"

/ {
	model = "TechNexion EDM-G-IMX8MP and WB baseboard";
	compatible = "fsl,imx8mp-edmg", "fsl,imx8mp";

	reg_usb_otg_vbus: usb_otg_vbus {
		pinctrl-names = "default";
		pinctrl-0 = <&pinctrl_otg_vbus>;
		compatible = "regulator-fixed";
		regulator-name = "usb_otg_vbus";
		regulator-min-microvolt = <3300000>;
		regulator-max-microvolt = <3300000>;
		gpio = <&gpio4 0 GPIO_ACTIVE_LOW>;
		enable-active-low;
	};

	reg_lvds_pwr: regulator_lvdspwr {
		pinctrl-names = "default";
		pinctrl-0 = <&pinctrl_lvds0_pwr>;
		compatible = "regulator-fixed";
		regulator-name = "lvds0_vdden";
		regulator-min-microvolt = <3300000>;
		regulator-max-microvolt = <3300000>;
		gpio = <&gpio4 12 GPIO_ACTIVE_HIGH>;
		enable-active-high;
	};

	reg_lvds_backlight_pwr: regulator_lvdsblpwr {
		pinctrl-names = "default";
		pinctrl-0 = <&pinctrl_lvds0_backlight_pwr>;
		compatible = "regulator-fixed";
		regulator-name = "lvds0_bl_en";
		regulator-min-microvolt = <3300000>;
		regulator-max-microvolt = <3300000>;
		gpio = <&gpio4 14 GPIO_ACTIVE_HIGH>;
		enable-active-high;
		regulator-always-on;
	};

	lvds_backlight: lvds_backlight {
		compatible = "pwm-backlight";
		pwms = <&pwm2 0 50000>;
		brightness-levels = <0 36 72 108 144 180 216 255>;
		default-brightness-level = <6>;
		status = "disabled";
	};

	usb_hub_rst: usb_hub_rst {
		compatible = "gpio-reset";
		pinctrl-names = "default";
		pinctrl-0 = <&pinctrl_usb_hub_ctrl>;
		reset-gpios = <&gpio4 22 GPIO_ACTIVE_LOW>;
		reset-delay-us = <10>;
		#reset-cells = <0>;
	};

	sound-wm8960 {
		compatible = "fsl,imx7d-evk-wm8960", "fsl,imx-audio-wm8960";
		model = "wm8960-audio";
		cpu-dai = <&sai3>;
		audio-codec = <&codec>;
		asrc-controller = <&easrc>;
		codec-master;
		/* JD2: hp detect high for headphone*/
		hp-det = <2 0>;
		audio-routing =
			"Headphone Jack", "HP_L",
			"Headphone Jack", "HP_R",
			"Ext Spk", "SPK_LP",
			"Ext Spk", "SPK_LN",
			"Ext Spk", "SPK_RP",
			"Ext Spk", "SPK_RN",
			"LINPUT1", "Mic Jack",
			"Mic Jack", "MICB",
			"CPU-Playback", "ASRC-Playback",
			"Playback", "CPU-Playback",
			"ASRC-Capture", "CPU-Capture",
			"CPU-Capture", "Capture";
	};

	clocks {
		codec_osc: aud_mclk {
			compatible = "fixed-clock";
			#clock-cells = <0>;
			clock-frequency = <24000000>;
			clock-output-names = "wm8960-mclk";
		};
	};

	gpio-leds {
		compatible = "gpio-leds";

		led {
			label = "gpio-led";
			gpios = <&pca9555_a23 1 GPIO_ACTIVE_HIGH>;
			default-state = "on";
		};
	};

};

&gpio1 {
	pinctrl-0 = <&pinctrl_gpio1>;
	gpio-line-names =	\
		"", "", "", "", "", "", "DSI_RST", "",	\
		"", "", "", "", "", "", "", "",	\
		"", "", "", "", "", "", "", "",	\
		"", "", "", "", "", "", "", "";
};

&gpio4 {
	pinctrl-0 = <&pinctrl_gpio4>;
	gpio-line-names =	\
		"", "", "", "", "", "", "GPIO_P249", "GPIO_P251",	\
		"", "GPIO_P255", "", "", "", "", "", "",	\
		"DSI_BL_EN", "DSI_VDDEN", "", "", "", "", "", "",	\
		"", "", "", "", "", "", "", "";
};

&snvs_pwrkey {
	status = "disabled";
};

&mipi_dsi {
	status = "disabled";
};

&mipi_csi_0 {
	status = "disabled";
};

&mipi_csi_1 {
	status = "disabled";
};

&i2c2 {
	status = "okay";

	codec: wm8960@1a {
		compatible = "wlf,wm8960";
		reg = <0x1a>;
		clocks = <&audio_blk_ctrl IMX8MP_CLK_AUDIO_BLK_CTRL_SAI3_MCLK1>;
		//clocks = <&codec_osc>;  /* Clock is from external osc on baseboard */
		clock-names = "mclk";
		wlf,shared-lrclk;
		wlf,hp-cfg = <3 2 3>;
		wlf,gpio-cfg = <1 3>;
	};

	typec_hd3ss3220: hd3ss3220@67 {
		compatible = "ti,hd3ss3220";
		interrupts-extended = <&gpio4 8 IRQ_TYPE_LEVEL_LOW>;
		pinctrl-names = "default";
		pinctrl-0 = <&pinctrl_hd3ss3220_irq>;
		vbus-supply = <&reg_usb_otg_vbus>;
		reg = <0x67>;

		ports {
			#address-cells = <1>;
			#size-cells = <0>;

			port@0 {
				reg = <0>;
				hd3ss3220_in_ep: endpoint {
					remote-endpoint = <&dwc3_out_ep>;
				};
			};

			port@1 {
				reg = <1>;
				hd3ss3220_out_ep: endpoint {
					remote-endpoint = <&dwc3_in_ep>;
				};
			};
		};
	};

	pca9555_a21: pca9555@21 {
		compatible = "nxp,pca9555";
		pinctrl-names = "default";
		pinctrl-0 = <&pinctrl_pca9555_a21_irq>;
		reg = <0x21>;
		gpio-controller;
		#gpio-cells = <2>;
		interrupt-controller;
		#interrupt-cells = <2>;
		interrupt-parent = <&gpio1>;
		interrupts = <10 IRQ_TYPE_LEVEL_LOW>;
		status = "okay";
		gpio-line-names = "EXPOSURE_TRIG_IN1", "FLASH_OUT1", "INFO_TRIG_IN1", "CAM_SHUTTER1", "XVS1", "PWR1_TIME0", "PWR1_TIME1", "PWR1_TIME2",
							"EXPOSURE_TRIG_IN2", "FLASH_OUT2", "INFO_TRIG_IN2", "CAM_SHUTTER2", "XVS2", "PWR2_TIME0", "PWR2_TIME1", "PWR2_TIME2";
	};

	pca9555_a23: pca9555@23 {
		compatible = "nxp,pca9555";
		pinctrl-names = "default";
		pinctrl-0 = <&pinctrl_pca9555_a23_irq>;
		reg = <0x23>;
		gpio-controller;
		#gpio-cells = <2>;
		interrupt-controller;
		#interrupt-cells = <2>;
		interrupt-parent = <&gpio4>;
		interrupts = <11 IRQ_TYPE_LEVEL_LOW>;
		status = "okay";
		gpio-line-names = "M2_DISABLE_N", "LED_EN", "", "", "", "", "", "USB_OTG_OC",
							"EXT_GPIO8", "EXT_GPIO9", "", "", "", "CSI1_PDB", "CSI2_PDB", "PD_FAULT";
	};

	ov5640_0: ov5640_mipi@3c {
		reg = <0x3c>;
		status = "disabled";
	};

	tevi_ar0521_0: tevi_ar0521@3d {
		reg = <0x3d>;
		status = "disabled";
	};

	tevi_ar0144_0: tevi_ar0144@3d {
		reg = <0x3d>;
		status = "disabled";
	};

	tevi_ar0234_0: tevi_ar0234@3d {
		reg = <0x3d>;
		status = "disabled";
	};

	vizionlink_0: vizionlink@30 {
		reg = <0x30>;
		status = "disabled";

		i2c_dev_list {
			#address-cells = <1>;
			#size-cells = <0>;

			vizionlink_pca9554_a25_0: vizionlink_pca9554@25 {
				reg = <0x25>;
				status = "disabled";
			};

			vizionlink_tevi_ov5640_0: vizionlink_ov5640_mipi@3c {
				reg = <0x3c>;
				status = "disabled";
			};

			vizionlink_tevi_ar0144_0: vizionlink_tevi_ar0144@3d {
				reg = <0x3d>;
				status = "disabled";
			};

			vizionlink_tevi_ar0234_0: vizionlink_tevi_ar0234@3d {
				reg = <0x3d>;
				status = "disabled";
			};

			vizionlink_tevi_ar0521_0: vizionlink_tevi_ar0521@3d {
				reg = <0x3d>;
				status = "disabled";
			};
		};
	};
};

&i2c4 {
	status = "okay";

	pn547: pn547@2a {
		compatible = "nxp,pn547";
		reg = <0x2a>;
		pinctrl-names = "default";
		pinctrl-0 = <&pinctrl_nfc>;
		clock-frequency = <100000>;
		interrupt-gpios = <&gpio4 10 0>;
		status = "okay";
	};
};

&i2c5 {
	clock-frequency = <400000>;

	ov5640_1: ov5640_mipi@3c {
		reg = <0x3c>;
		status = "disabled";
	};

	tevi_ar0521_1: tevi_ar0521@3d {
		reg = <0x3d>;
		status = "disabled";
	};

	tevi_ar0144_1: tevi_ar0144@3d {
		reg = <0x3d>;
		status = "disabled";
	};

	tevi_ar0234_1: tevi_ar0234@3d {
		reg = <0x3d>;
		status = "disabled";
	};

	vizionlink_1: vizionlink@30 {
		reg = <0x30>;
		status = "disabled";

		i2c_dev_list {
			#address-cells = <1>;
			#size-cells = <0>;

			vizionlink_pca9554_a25_1: vizionlink_pca9554@25 {
				reg = <0x25>;
				status = "disabled";
			};

			vizionlink_tevi_ov5640_1: vizionlink_ov5640_mipi@3c {
				reg = <0x3c>;
				status = "disabled";
			};

			vizionlink_tevi_ar0144_1: vizionlink_tevi_ar0144@3d {
				reg = <0x3d>;
				status = "disabled";
			};

			vizionlink_tevi_ar0234_1: vizionlink_tevi_ar0234@3d {
				reg = <0x3d>;
				status = "disabled";
			};

			vizionlink_tevi_ar0521_1: vizionlink_tevi_ar0521@3d {
				reg = <0x3d>;
				status = "disabled";
			};
		};
	};
};

&flexcan1 {
	status = "okay";
};

&flexcan2 {
	status = "disabled";
};

&usb_dwc3_0 {
	dr_mode = "otg";
	pinctrl-names = "default";
	usb-role-switch;
	status = "okay";

	ports {
		#address-cells = <1>;
		#size-cells = <0>;

		port@0 {
			reg = <0>;
			dwc3_out_ep: endpoint {
				remote-endpoint = <&hd3ss3220_in_ep>;
			};
		};

		port@1 {
			reg = <1>;
			dwc3_in_ep: endpoint {
				remote-endpoint = <&hd3ss3220_out_ep>;
			};
		};
	};
};

&usb_dwc3_1 {
	dr_mode = "host";
	status = "okay";
	resets = <&usb_hub_rst>;
};

&pcie{
	ext_osc = <1>;
	status = "okay";
};

&pcie_phy{
	ext_osc = <1>;
	status = "okay";
};

&iomuxc {
	pinctrl_otg_vbus: otgvbusgrp {
		fsl,pins = <
			MX8MP_IOMUXC_SAI1_RXFS__GPIO4_IO00		0x19 /* USB_OTG_PWR_EN */
		>;
	};

	pinctrl_usb_hub_ctrl: usbhubctrlgrp {
		fsl,pins = <
			MX8MP_IOMUXC_SAI2_RXC__GPIO4_IO22		0x41 /* USB_HUB_RESET */
		>;
	};

	pinctrl_hd3ss3220_irq: hd3ss3220_irqgrp {
		fsl,pins = <
			MX8MP_IOMUXC_SAI1_RXD6__GPIO4_IO08		0x41 /* GPIO_P253 */
		>;
	};

	pinctrl_lvds0_backlight_pwr: lvds0_bl_pwrgrp {
		fsl,pins = <
			MX8MP_IOMUXC_SAI1_TXD2__GPIO4_IO14		0x19 /* LVDS0_BL_EN */
		>;
	};

	pinctrl_lvds0_pwr: lvds0_pwrgrp {
		fsl,pins = <
			MX8MP_IOMUXC_SAI1_TXD0__GPIO4_IO12		0x19 /* LVDS0_VDDEN */
		>;
	};

	pinctrl_touch_reset: touch_rstgrp {
		fsl,pins = <
			MX8MP_IOMUXC_SAI1_TXD1__GPIO4_IO13		0x41 /* TOUCH_nRST, LVDS1_VDDEN */
		>;
	};

	pinctrl_pca9555_a21_irq: pca9555_a21_irqgrp {
		fsl,pins = <
			MX8MP_IOMUXC_GPIO1_IO10__GPIO1_IO10		0x140 /* SPI_B_SS0 */
		>;
	};

	pinctrl_pca9555_a23_irq: pca9555_a23_irqgrp {
		fsl,pins = <
			MX8MP_IOMUXC_SAI1_TXC__GPIO4_IO11		0x140 /* GPIO_P247 */
		>;
	};

	pinctrl_gpio1: gpio1grp {
		fsl,pins = <
			MX8MP_IOMUXC_GPIO1_IO06__GPIO1_IO06		0x16 /* DSI_RST */
		>;
	};

	pinctrl_gpio4: gpio4grp {
		fsl,pins = <
			MX8MP_IOMUXC_SAI1_RXD4__GPIO4_IO06		0x16 /* GPIO_P249 */
			MX8MP_IOMUXC_SAI1_RXD5__GPIO4_IO07		0x16 /* GPIO_P251 */
			MX8MP_IOMUXC_SAI1_RXD7__GPIO4_IO09		0x16 /* GPIO_P255 */
			MX8MP_IOMUXC_SAI1_TXD4__GPIO4_IO16		0x16 /* DSI_BL_EN */
			MX8MP_IOMUXC_SAI1_TXD5__GPIO4_IO17		0x16 /* DSI_VDDEN */
		>;
	};

	pinctrl_nfc: nfcgrp {
		fsl,pins = <
			MX8MP_IOMUXC_SAI1_TXFS__GPIO4_IO10		0x41 /* DSI_RST */
		>;
	};

        pinctrl_touch_irq: touch_irqgrp {
		fsl,pins = <
			MX8MP_IOMUXC_SAI1_TXD3__GPIO4_IO15	0x41   /* Touch INT */
		>;
	};
};
